/***************************************************************************
 *   basecode - archive of useful C++ classes                              *
 *   Copyright (C) 2004 by Michal Turek - Woq                              *
 *   WOQ (at) seznam.cz, http://woq.nipax.cz/                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CTEAM_H__
#define __CTEAM_H__

#include <string>
#include <sstream>
#include <SDL.h>
#include <SDL_opengl.h>

#include "basecode.h"
#include "cplayer.h"
#include "cimage.h"

using namespace std;

#define DEFAULT_NUM_PLAYERS 4
#define DEFAULT_PLAYER_TEXTURE "./data/players/default.png"

// INI
#define BEGIN_NAME "player"

namespace basecode
{

class CTeam
{
public:
	CTeam();
	~CTeam();
	void Init(const string& filename);
			//throw(std::bad_alloc, CFileNotFound, CBadFileFormat);
	void Destroy();

	void SelectNext();
	void SelectPrevious();

	const CPlayer& GetSelected() const throw(logic_error);

private:
	CPlayer* m_players;
	int m_num_players;
	int m_selected;
	string m_name;
	GLuint* m_textures;

	// TODO: It is loaded but not freed :-(
	static GLuint m_default_texture;
};

}

#endif
